<template>
  <div class="accordion" role="tablist">
    <div>
      <b-card no-body class="mb-1">
        <b-card-header header-tag="header" class="p-1" role="tab">
          <b-button
            block
            v-b-toggle="layer.id.toString()"
            variant="secondary"
            class="titleStyle"
          >
            {{ layer.name }}
          </b-button>
        </b-card-header>

        <b-collapse
          :id="layer.id.toString()"
          accordion="my-accordion"
          role="tabpanel"
        >
          <b-card-body>
            <b-button
              id="add_layer"
              variant="outline-dark"
              size="sm"
              class="mb-2"
              :disabled="disable"
              @click="addtoLayerList(layer)"
            >
              <b-icon icon="plus" aria-label="add" scale="2" />
            </b-button>
            <b-alert
              v-model="visible"
              variant="warning"
              dismissible
              class="alertStyle"
            >
              {{ $t("message.date_alert_message") }}
            </b-alert>
            <b-alert
              v-model="date_visible"
              variant="warning"
              dismissible
              class="alertStyle"
            >
              این تاریخ قبلا انتخاب شده است
            </b-alert>

            <multiselect
              v-model="date"
              :options="layer.dates"
              :searchable="true"
              :close-on-select="true"
              :show-labels="false"
              :placeholder="$t('message.multiselect_placeholder_date')"
              @input="onChangeValue"
            />
            <b-card-text class="descriptionStyle">
              {{ layer.description }}
              <!-- <strong>
                {{ layer.resolution.pixel }}
              </strong> -->
            </b-card-text>
          </b-card-body>
        </b-collapse>
      </b-card>
    </div>
  </div>
</template>
<script>
export default {
  data() {
    return {
      date: "",
      visible: false,
      date_visible: false,
      disable: false,
    };
  },
  props: {
    layer: { type: Object },
    addLayerToSelectedLayers: Function,
    selectedLayers: { type: Array },
  },
  methods: {
    addtoLayerList(layer) {
      if (this.date === "" || this.date === null) {
        this.visible = true;
      } else {
        this.visible = false;
        this.addLayerToSelected(layer);
      }
    },
    onChangeValue(value) {
      if (value !== null) {
        this.visible = false;
        if (this.selectedLayers.length > 0) {
          let array = this.selectedLayers,
            layer = this.layer;
          let itemIndex = array.map(function(item){
            if (item.id === layer.id && item.date === value) {
              this.disable = true;
              this.date_visible = true;
            } else {
              this.disable = false;
              this.date_visible = false;
            }
          }, this);
        }
      }
    },
    checkForDisablingAdd(self) {
      let array = self.selectedLayers,
        layer = self.layer;
      array.map((item) => {
        if (item.id === layer.id && item.date === self.date) {
          self.disable = true;
          self.date_visible = true;
          debugger;
        } else {
          self.disable = false;
          self.date_visible = false;
        }
      });
    },
    addLayerToSelected(layer) {
      let selectedLayer = {
        date: this.date,
        description: layer.description,
        id: layer.id,
        name: layer.name,
        resolution: layer.resolution.pixel,
      };
      this.addLayerToSelectedLayers(selectedLayer);
    },
  },
};
</script>

<style scoped>
.alertStyle {
  text-align: right;
}
.descriptionStyle {
  text-align: right;
  margin-top: 5%;
}
.titleStyle {
  font-weight: bold;
  text-align: right;
}
</style>